
// Duplicated code !!!

// CIDs
const NS_PREFSERVICE_CONTRACTID = "@mozilla.org/preferences-service;1";
const CONSOLE_CONTRACTID = "@mozilla.org/consoleservice;1";

// interfaces
const ifs                   = Components.interfaces;
const nsIPrefService        = ifs.nsIPrefService;
const nsIConsoleService     = ifs.nsIConsoleService;

const LE_MIME_TYPE     = "application/x-nuxeo-liveedit";
const ACCEPT_PREF_BROWSER_KEY  = "network.http.accept.default";
const PREF_BRANCH   = "extensions.nxedit.";
const NXDEBUG=true;

function debugLog(msg)
{
    if (NXDEBUG)
    {
     dump(msg+ "\n");
     Components.classes[CONSOLE_CONTRACTID].getService(nsIConsoleService).logStringMessage(msg+ "\n");
    }
}


setupAcceptHeaderIfNeeded = function(mimeTypeMap)
{
    debugLog("standAlone:setupAcceptHeaderIfNeeded");

    var PrefService = Components.classes[NS_PREFSERVICE_CONTRACTID].getService(nsIPrefService);
    var prefs = PrefService.getBranch("");

   //setup mime-types config for accept header
    var currentAccept = prefs.getCharPref(ACCEPT_PREF_BROWSER_KEY);
    var idx = currentAccept.indexOf(LE_MIME_TYPE);
    var targetHeader = LE_MIME_TYPE
    
    var mts = mimeTypeMap.getKeys();
    for (i=0;i<mts.length;i++)
    {
       targetHeader=targetHeader+";" + mts[i].replace("/","!");
    }
    if (idx<0)
    {
       debugLog("adding liveedit to accept header:" + targetHeader);
       // set the accept header
       var idx2 = currentAccept.lastIndexOf(",");
       if (idx2<currentAccept.length-1)
          currentAccept=currentAccept+",";
       currentAccept=currentAccept + targetHeader;
    }
    else
    {
       // update accept header
       debugLog("check for update of the accept header:" + targetHeader);
       // get existing header
       var idx2 = currentAccept.indexOf(",",idx);
       debugLog("idx2=" + idx2);
       var existingHeader="";
       if (idx2<0)
       {
           existingHeader=currentAccept.substring(idx);
       }
       else
       {
           existingHeader=currentAccept.substring(idx,idx2-idx);
       }
       debugLog("existing Header=" + existingHeader);    
       if (existingHeader==targetHeader)
          {
	       debugLog("Accept Header is already OK");            
               return;
          }
       else
          {
	       debugLog("Accept Header needs to be updated");            
	       currentAccept=currentAccept.replace(existingHeader,targetHeader);
               debugLog("new value = " + currentAccept);            
	  }
    }
    prefs.setCharPref(ACCEPT_PREF_BROWSER_KEY,currentAccept);
    debugLog("LiveEdit accept header set to " + currentAccept);
}


